import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class StringComp {

    public static Comparator<String> compareLengthFirst() {
        return new Comparator<String>() {
            @Override
            public int compare(String a, String b) {
                if (a.length() == b.length()) {
                    return a.compareTo(b);
                } else {
                    return a.length() - b.length();
                }
            }
        };
    }

    public static Comparator<String> compareExcludingLetter(char c) {
        return new Comparator<String>() {
            @Override
            public int compare(String a, String b) {
                boolean aStartsWithC = a.charAt(0) == c;
                boolean bStartsWithC = b.charAt(0) == c;
                 if (aStartsWithC && !bStartsWithC) {
                    return Integer.MAX_VALUE;
                } else if (bStartsWithC && !aStartsWithC) {
                    return Integer.MIN_VALUE;
                } else {
                    return a.compareTo(b);
                }
            }
        };
    }

    public static void main(String[] args) {
        List<String> l = new ArrayList<>();
        l.add("act");
        l.add("hi");
        l.add("h");
        l.add("hello");
        l.add("ha");

        Collections.sort(l, compareLengthFirst());
        System.out.println(l);

        Collections.sort(l, compareExcludingLetter('a'));
        System.out.println(l);
    }
}
